﻿Imports System.IO
Imports System.Net.Mail

Public Class errorReport

    Dim LangPath As String
    Dim ReportAddress As String
    Dim ReportSmtp As String

    Dim Lang(20) As String

    Dim App As ApplicationServices.AssemblyInfo
    Dim Err As Exception
    Dim Clock As DateTime


    Public Sub LoadData(ByVal AppInfo As ApplicationServices.AssemblyInfo, ByVal ErrData As Exception)
        App = AppInfo
        Err = ErrData
        Clock = Now
    End Sub

    Private Sub MakeHTML()
        Dim strFilename As String = Path.GetTempFileName() + ".html"
        Dim objFS As New FileStream(strFilename, System.IO.FileMode.Append, System.IO.FileAccess.Write)
        Dim Writer As New StreamWriter(objFS)
        Dim css As String = "<html><head><title>ErrorReporter.NET</title><style type='text/css'>body{font-family:Helvetica;background:#ffff99}h1,h2,h4{text-align:center}#content{width:700px;margin:0 auto}#block{background:#9999ff;padding:10px;margin:10px}.monospaced{font-family:Courier}</style></head>"
        Dim html As String = String.Format("<body><div id='content'><h4>ErrorReporter.NET</h4><h1>{0}</h1><div id='block'><h2>{1}</h2><p><b>{2}</b> {3}<br><b>{4}</b> {5}<br><b>{6}</b> {7}<br><b>{8}</b> {9}<br></p></div><div id='block'><h2>{10}</h2><p><b>{11}</b> {12}<br><b{13}</b> {14}<br><b>{15}</b><span class='monospaced'>{16}</span><br></p></div><div id='block'><h2>{17}</h2><p><b>{18}</b> {19}<br><b>{20}</b> {21}<br></p></div></div></body></html>", App.Title, App.Version, Clock, System.Environment.OSVersion.ToString, Err.GetType.ToString, Err.Message, Err.StackTrace, txtMail.Text, txtDescription.Text)
        Writer.BaseStream.Seek(0, System.IO.SeekOrigin.End)
        Writer.WriteLine(css + html)
        Writer.Flush()
        Writer.Close()
        Process.Start(strFilename)
    End Sub

    Private Sub SendReport() 'Freeze (chiesto sul forum)
        Dim Mail As New MailMessage()
        Mail.From = New MailAddress(App.Title.Replace(" ", "_") + "@errorReport.NET")
        Mail.To.Add(ReportAddress)

        Mail.Subject = "This is an email"
        Mail.Body = "this is a sample body"

        Dim Smtp As New SmtpClient("smtp.gmail.com", 465)
        Smtp.EnableSsl = True
        Try
            Smtp.Send(Mail)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub ReadConf()
        Dim Reader As New StreamReader("ErrorReporter.NET\conf.cfg")
        LangPath = Reader.ReadLine()
        ReportAddress = Reader.ReadLine
    End Sub

    Private Sub SetLanguage()
        Try
            Dim Reader As New StreamReader(LangPath)
            For i = 0 To 20
                Lang(i) = Reader.ReadLine()
            Next
            Me.Text = String.Format(Lang(0), App.Title)
            lblMain.Text = String.Format(Lang(0), App.Title)
            tabGeneral.Text = Lang(1)
            tabAdvanced.Text = Lang(2)
            groupInfo.Text = Lang(3)
            groupOptional.Text = Lang(4)
            lblApp.Text = Lang(5)
            lblVersion.Text = Lang(6)
            lblDateTime.Text = Lang(7)
            lblMessage.Text = Lang(8)
            lblOS.Text = Lang(9)
            lblMail.Text = Lang(10)
            lblDescription.Text = Lang(11)
            lblErrType.Text = Lang(12)
            lblStackTrace.Text = Lang(13)
            btnSend.Text = Lang(14)
            btnQuit.Text = Lang(15)
        Catch ex As IO.FileNotFoundException
            MsgBox(ex.Message, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub Populate()
        txtApp.Text = App.Title
        txtVersion.Text = App.Version.ToString
        txtDateTime.Text = Clock
        txtMessage.Text = Err.Message
        txtOS.Text = System.Environment.OSVersion.ToString
        txtErrType.Text = Err.GetType.ToString
        txtStackTrace.Text = Err.StackTrace
    End Sub

#Region "Events"
    Private Sub errorReport_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ReadConf()
        SetLanguage()
        Populate()
    End Sub

    Private Sub errorReport_FormClosing(sender As Object, e As Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Dim result As MsgBoxResult = MsgBox(String.Format(Lang(16), vbCrLf), MsgBoxStyle.YesNo)
        If result = MsgBoxResult.No Then
            e.Cancel = True
        End If
    End Sub

    Private Sub btnQuit_Click(sender As Object, e As EventArgs) Handles btnQuit.Click
        Me.Close()
    End Sub

    Private Sub btnSend_Click(sender As Object, e As EventArgs) Handles btnSend.Click
        'MakeHTML()
        SendReport()
    End Sub
#End Region

End Class